# This file was automatically generated by bifcl from /usr/src/packages/BUILD/src/packet_analysis/protocol/teredo/events.bif (plugin mode).

export {
module GLOBAL;


## Generated for any IPv6 packet encapsulated in a Teredo tunnel.
## See :rfc:`4380` for more information about the Teredo protocol.
##
## outer: The Teredo tunnel connection.
##
## inner: The Teredo-encapsulated IPv6 packet header and transport header.
##
## .. zeek:see:: teredo_authentication teredo_origin_indication teredo_bubble
##
## .. note:: Since this event may be raised on a per-packet basis, handling
##    it may become particularly expensive for real-time analysis.
global teredo_packet: event(outer: connection , inner: teredo_hdr );


## Generated when per connection Teredo state is created.
##
## This is primarily useful to install a connection removal hook to clear
## internal per-connection Teredo state.
##
## c: The Teredo tunnel connection.
global new_teredo_state: event(c: connection );


## Generated for IPv6 packets encapsulated in a Teredo tunnel that
## use the Teredo authentication encapsulation method.
## See :rfc:`4380` for more information about the Teredo protocol.
##
## outer: The Teredo tunnel connection.
##
## inner: The Teredo-encapsulated IPv6 packet header and transport header.
##
## .. zeek:see:: teredo_packet teredo_origin_indication teredo_bubble
##
## .. note:: Since this event may be raised on a per-packet basis, handling
##    it may become particularly expensive for real-time analysis.
global teredo_authentication: event(outer: connection , inner: teredo_hdr );


## Generated for IPv6 packets encapsulated in a Teredo tunnel that
## use the Teredo origin indication encapsulation method.
## See :rfc:`4380` for more information about the Teredo protocol.
##
## outer: The Teredo tunnel connection.
##
## inner: The Teredo-encapsulated IPv6 packet header and transport header.
##
## .. zeek:see:: teredo_packet teredo_authentication teredo_bubble
##
## .. note:: Since this event may be raised on a per-packet basis, handling
##    it may become particularly expensive for real-time analysis.
global teredo_origin_indication: event(outer: connection , inner: teredo_hdr );


## Generated for Teredo bubble packets.  That is, IPv6 packets encapsulated
## in a Teredo tunnel that have a Next Header value of :zeek:id:`IPPROTO_NONE`.
## See :rfc:`4380` for more information about the Teredo protocol.
##
## outer: The Teredo tunnel connection.
##
## inner: The Teredo-encapsulated IPv6 packet header and transport header.
##
## .. zeek:see:: teredo_packet teredo_authentication teredo_origin_indication
##
## .. note:: Since this event may be raised on a per-packet basis, handling
##    it may become particularly expensive for real-time analysis.
global teredo_bubble: event(outer: connection , inner: teredo_hdr );


} # end of export section
module GLOBAL;
